% This MATLAB code offers a GPT-4o demonstration as described in the paper:
% De Winter, J. C. F. (2024). Code and explanation for the use of GPT-4o for demonstration purposes. http://doi.org/10.13140/RG.2.2.24898.39364

% First download the imencode function from https://nl.mathworks.com/matlabcentral/fileexchange/39526-byte-encoding-utilities

close all
clear clear cam
clc

% comment based on your preference
cam = webcam;

%cam = webcam('Cam Link 4K');
%cam = webcam('OV02C10');
%cam = webcam('EƖgato Virtual Camera');

%cam.Resolution='3840x2160';
cam.Resolution='1920x1080';

Prompt = 'Beschrijf wat te zien is met verassende precisie, in 20 woorden; geef ook een trefwoord op de volgende regel wat betreft de emotie: "EMOTIE: ...";  en geef een trefwoord op de volgende regel wat betreft: "SFEER: ..."  en geef een trefwoord op de volgende regel wat betreft: "POSITIEF ELEMENT: ..."  en tot slot wat betreft: "NEGATIEF ELEMENT: ..."';

key % read the API key as a variable 'api-key'
header = HeaderField('Authorization', api_key);
import matlab.net.http.* matlab.net.*  matlab.net.http.io.*

encoder = org.apache.commons.codec.binary.Base64;
fg=figure;

for i=1:10000 % loop over a maximum of 10,000 video frames. This will ensure that the costs remains bounded
    try
        im = snapshot(cam);
        imageraw = imencode(imresize(im,0.50), 'jpg'); % use downsampled image for the API
        base64string = char(encoder.encode(imageraw))';

        prompt  = struct('type','text','text',Prompt);
        image1   = struct('url',['data:image/jpeg;base64,' base64string]);
        images1  = struct('type','image_url','image_url',image1);

        content = {{struct('role','user','content',{{prompt images1}})}};
        message = struct('model','gpt-4o','messages',content,'max_tokens',1000);
        body = JSONProvider(message);
        response = RequestMessage('post', header, body).send(URI('https://api.openai.com/v1/chat/completions').EncodedURI);

        output = response.Body.Data.choices.message.content;
        output = strrep(output,[newline newline],newline); % remove double white lines

        im=insertText(im,[10,10],output, 'Fontsize',round(26/(1920/size(im,2))),'boxcolor',[247, 150, 71]); % overlay the text on the raw camera image
        imshow(im);

        if i==1 % maximize the screen
            set(fg, 'WindowState', 'fullscreen');
            axis off;
            set(fg, 'MenuBar', 'none');
            set(fg, 'ToolBar', 'none');
            set(gca,'Position',[0 0 1 1])
        end
        hold on
        drawnow
    catch error
    end
end